> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/databases/mariadb/overview/features-benefits.md).

# Features and Benefits

## Features

* **ACID Compliance:** MariaDB ensures data integrity and reliability through the support of Atomicity, Consistency, Isolation, and Durability (ACID) properties.
* **Triggers and Stored Procedures:** MariaDB allows the creation of database triggers to automatically perform actions based on specified events and stored procedures for executing sets of SQL statements.
* **User Management and Security:** Database access can be restricted to authorized users only. Role-based access control, robust encryption support, and user management tools ensure secure access and data protection.
* **Indexes and Storage Engines:** MariaDB supports various types of indexes to enhance query performance. In addition, it supports storage engines such as InnoDB, MyISAM, and Aria, thus offering flexibility and performance optimization for different use cases.
* **Query Optimizer and Performance Tuning:** MariaDB's query optimizer and performance tuning capabilities help improve database efficiency and query execution speed.
* **Full-Text Search:** Integrated full-text search support enables efficient and flexible text searching within large volumes of data.
* **Data Compression:** Data compression techniques reduce storage requirements and improve query performance.
* **Columns Support:**
  * **Virtual (Computed) Columns** enable column definitions based on expressions, thus enhancing data retrieval capabilities.
  * **Dynamic Columns** capability allows storing different column sets for each row, thus enabling flexible schema design.
* **Transactional Support:** Comprehensive transaction support, allowing complex operations with rollback capabilities for data integrity.
* **SQL Support:** Full support for standard SQL and JSON functionalities, facilitating seamless integration with existing applications and tools.

## IONOS CLOUD DBaaS Features

* **Upgrades:** <code class="expression">space.vars.ionos\_cloud</code> DBaaS supports user-defined maintenance windows with minimal service disruption. The database may be unreachable for a few seconds when necessary for restarts or switching to another replica. Single-node clusters temporarily gain a second node when it is necessary to replace the old one. Hence, maintenance downtime is the same for multi-node and single-node clusters.
* **Backups:** Base backups are carried out daily with Point-in-Time recovery. For the MariaDB v1 API, backups are retained for one week. For the MariaDB v2 API, retention is configurable from 1 to 365 days using the `backup.retentionDays` property.
* **Database Monitoring and Reporting:** MariaDB provides tools for performance monitoring, query analysis, and reporting to help optimize database usage and identify potential issues.
* **Self-restore a MariaDB cluster:** <code class="expression">space.vars.ionos\_cloud</code> DBaaS for MariaDB allows you to automatically restore your MariaDB clusters to a prior state or point in time. In unanticipated circumstances, this dependable feature minimizes data loss and reduces downtime. For more information, refer to the instructions for restoring through the [<mark style="color:blue;">DCD</mark>](/cloud/databases/mariadb/how-tos/v2/restore-mariadb-cluster.md) or the [<mark style="color:blue;">API</mark>](https://docs.ionos.com/cloud/api-reference/databases/mariadb/).
* **Observability (v2):** Forward cluster logs and metrics to your <code class="expression">space.vars.ionos\_cloud</code> Observability services by enabling `logsEnabled` and `metricsEnabled` on the cluster. The observability service must be activated on your contract for these settings to take effect.

## Benefits

* **Simplified Configuration:** Configure your MariaDB instance in compliance with <code class="expression">space.vars.ionos\_cloud</code> DBaaS's specifications. You can quickly create databases and tables, define user roles, and assign permissions similar to a physical database using SQL commands, <code class="expression">space.vars.ionos\_cloud</code> graphical interface, or API commands.
* **Scalable:** Because of MariaDB's vertical scalability, storage, memory, and cores may be added to match the growing demand for greater processing power for data.
* **High availability:** Automatic node failure handling for multi-node clusters.
* **Security:** The communication between clients and databases is secured using TLS for secure data transmission if your MariaDB database is set up to use it.
* **Programmatic Resource Management:** Simplified deployment and management in cloud environments through APIs, SDKs, and configuration management tools.
* **Resources:** It is offered on Enterprise VM, with a dedicated CPU, storage, and RAM. Currently, MariaDB Engine v2 only supports [<mark style="color:blue;">Performance</mark>](/cloud/backup-and-storage/block-storage/overview/storage-performance.md#storage-performance) storage.
* **Network:** DBaaS supports private LANs only.
* **JSON and GIS Support:** Effectively storing and querying spatial data and JSON documents is possible with native support for Geographic Information System (GIS) and JSON functions.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.ionos.com/cloud/databases/mariadb/overview/features-benefits.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
